// ignore_for_file: use_build_context_synchronously
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:base_project/BuilderField/shared/ui/entity_list.dart';
import 'Basicp3_create_entity_screen.dart';
import 'Basicp3_update_entity_screen.dart';
import '../Basicp3_viewModel/Basicp3_view_model_screen.dart';
import 'Basicp3_details_screen.dart';import 'package:flutter/services.dart';
import 'package:speech_to_text/speech_to_text.dart' as stt;
import '../../../../theme/app_style.dart';
import '../../../../utils/size_utils.dart';
import '../../../../widgets/custom_icon_button.dart';
import '../../../../utils/image_constant.dart';
import '../../../../widgets/app_bar/appbar_image.dart';
import '../../../../widgets/app_bar/appbar_title.dart';
import '../../../../widgets/app_bar/custom_app_bar.dart';
import '../../../../theme/app_decoration.dart';
import 'package:multi_select_flutter/multi_select_flutter.dart';
import '../../../../Reuseable/reusable_text_field.dart';
import 'package:provider/provider.dart';
import '../../../../utils/toast_messages/toast_message_util.dart';
import 'package:fluttertoast/fluttertoast.dart';

class Basicp3_entity_list_screen extends StatefulWidget {
  static const String routeName = '/entity-list';

  @override
  _Basicp3_entity_list_screenState createState() => _Basicp3_entity_list_screenState();
}

class _Basicp3_entity_list_screenState extends State<Basicp3_entity_list_screen> {
  @override
  void initState() {
    super.initState();
    _loadData();
  }

  void _loadData() {
    WidgetsBinding.instance.addPostFrameCallback((_) {
      if (mounted) {
        final vm = Provider.of<Basicp3ViewModelScreen>(context, listen: false);
        vm.getAllWithPagination(refresh: true);
      }
    });
  }

  void _navigateToCreateScreen() {
    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (context) => ChangeNotifierProvider(
          create: (context) => Basicp3ViewModelScreen(),
          child: const Basicp3CreateEntityScreen(),
        ),
      ),
    ).then((_) {
      final vm = Provider.of<Basicp3ViewModelScreen>(context, listen: false);
      vm.refreshData();
    });
  }

  void _navigateToUpdateScreen(Map<String, dynamic> entity) {
    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (context) => ChangeNotifierProvider(
          create: (context) => Basicp3ViewModelScreen(),
          child: Basicp3UpdateEntityScreen(entity: entity),
        ),
      ),
    ).then((_) {
      final vm = Provider.of<Basicp3ViewModelScreen>(context, listen: false);
      vm.refreshData();
    });
  }

  void _navigateToDetailsScreen(Map<String, dynamic> entity) {
    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (context) => ChangeNotifierProvider(
          create: (context) => Basicp3ViewModelScreen(),
          child: Basicp3DetailsScreen(entity: entity),
        ),
      ),
    );
  }

  void _showDeleteDialog(Map<String, dynamic> entity) {
 final parentContext = context; 
    showDialog(
      context: context,
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text('Confirm Deletion'),
          content: const Text('Are you sure you want to delete this Basicp3?'),
          actions: [
            TextButton(
              child: const Text('Cancel'),
              onPressed: () {
                Navigator.of(context).pop();
              },
            ),
            TextButton(
              child: const Text('Delete'),
              onPressed: () async {
                Navigator.of(context).pop();
                final vm =
                    Provider.of<Basicp3ViewModelScreen>(parentContext, listen: false);
                await vm.deleteEntity(entity['id']);
              },
            ),
          ],
        );
      },
    );
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<Basicp3ViewModelScreen>(
      builder: (context, viewModel, child) {
        return EntityList(
          entities: viewModel.filteredList,
          isLoading: viewModel.isLoading,
          errorMessage:
              viewModel.errorMessage.isNotEmpty ? viewModel.errorMessage : null,
          hasMoreData: viewModel.hasMoreData,
          searchQuery: viewModel.searchQuery,
          onSearchChanged: (query) => viewModel.searchbasicp3(query),
          onEdit: (entity) => _navigateToUpdateScreen(entity),
          onDelete: (entity) => _showDeleteDialog(entity),
          onTap: (entity) => _navigateToDetailsScreen(entity),
          onRefresh: () => viewModel.refreshData(),
          onLoadMore: () => viewModel.getAllWithPagination(),
          title: 'Basicp3',
          onAddNew: _navigateToCreateScreen,
          displayFields: [
  {'key': 'toggle_switch', 'label': 'Toggle Switch', 'type': 'toggle_switch'},

  {'key': 'toggle_switch2', 'label': 'Toggle Switch2', 'type': 'toggle_switch'},

  {'key': 'url_field', 'label': 'Url Field', 'type': 'url'},

  {'key': 'url_field2', 'label': 'Url Field2', 'type': 'url'},

  {'key': 'decimal_field', 'label': 'Decimal Field', 'type': 'decimal'},

  {'key': 'decimal_field2', 'label': 'Decimal Field2', 'type': 'decimal'},

  {'key': 'percentage_field', 'label': 'Percentage Field', 'type': 'number'},

  {'key': 'percentage_field2', 'label': 'Percentage Field2', 'type': 'number'},

  {'key': 'documentsequenc', 'label': 'documentsequenc', 'type': 'document_sequence'},

  {'key': 'recaptcha', 'label': 'recaptcha', 'type': 'recaptcha'},

  {'key': 'recaptcha2', 'label': 'recaptcha2', 'type': 'recaptcha'},

          ],
        );
      },
    );
  }
}
